<?php 

header ('Cache-control: public, must-revalidate');
header ('Expires: '.gmdate('D, d M Y H:i:s', time() + 60 * 60 * 24) . ' GMT');
header ("Content-type: text/css; charset: UTF-8");

$absolute_path = explode('wp-content', $_SERVER['SCRIPT_FILENAME']);
$wp_load = $absolute_path[0] . 'wp-load.php';

require_once $wp_load;  

$cssOptions = pvg_options::opninst ()->get_galOptions () ;    

$styles = array (
	"R" => "bolder",
	"B" => "bold",
	"N" => "normal", 
	"I" => "italic",
);

//Width Calculation
$ints = $cssOptions ['iprw'];
$calc = round (100 / $ints);

//Player Size
$pvg_ph = $cssOptions ['phgt'] ; // player height
$pvg_pw = $cssOptions ['pwdt']; // player width

//Thumbnail Size
$pvg_th = $cssOptions ['thgt']; // thumb height
$pvg_tw = $cssOptions ['twdt']; // thumb widt h
$pvg_tc = $cssOptions ['twdt'];  // thumb enclose r
$pvg_ts = $cssOptions ['twdt']; // thumb separator   

//Thumbnail Style
$paddingW = ($cssOptions ['tbpz'])?"padding: {$cssOptions ['tbpz']}px;":"";
$paddingC = ($cssOptions ['tbbg'])?"background-color:{$cssOptions ['tbbg']};":"";
$borderW  = ($cssOptions ['tbbz'])?"border-width: {$cssOptions ['tbbz']}px;":"";
$borderR  = ($cssOptions ['tbmr'])?"border-radius:{$cssOptions ['tbmr']}px;
									-o-border-radius:{$cssOptions ['tbmr']}px;
									-moz-border-radius:{$cssOptions ['tbmr']}px;
									-khtml-border-radius:{$cssOptions ['tbmr']}px;
									-webkit-border-radius:{$cssOptions ['tbmr']}px;":"";
$borderC  = ($cssOptions ['tbbc'])?"border-color: {$cssOptions ['tbbc']};":"";
$borderS  = ($cssOptions ['tbbs'])?"border-style: {$cssOptions ['tbbs']};":"";
$textL    = ($cssOptions ['tbtl'])?"line-height: {$cssOptions ['tbtl']}px;":"";
$textW    = ($cssOptions ['tbtw'])?"font-weight: {$styles [$cssOptions ['tbtw']]};":"";
$textS    = ($cssOptions ['tbts'])?"font-style: {$styles [$cssOptions ['tbts']]};":"";
$textZ    = ($cssOptions ['tbtz'])?"font-size: {$cssOptions ['tbtz']}px;":"";
$textB    = ($cssOptions ['tbtb'] == "Y")?"word-break: break-all;":"word-break: keep-all";
$textC    = ($cssOptions ['tbtc'])?"color: {$cssOptions ['tbtc']};":"";
$textH    = ($cssOptions ['tbth'])?"color: {$cssOptions ['tbth']};":"";
$bandP    = ($cssOptions ['tbbz']) + ($cssOptions ['tbpz']);

?>

#pvg_videos:after {
	content: ".";
	display: block;
	overflow: auto;
	visibility: hidden;
	line-height: 0;
	height: 0;
}

#pvg_videos {
	zoom: 1;
}

#pvg_videos div.pvg_iframe {
	display:none;
}

#pvg_videos:first-of-type .pvg_iframe {
	display:block;
}

#pvg_videos .pvg_container * {
	transition-duration: 0.25s;
}

#pvg_videos .pvg_container {
	min-width: <?php echo $pvg_ts + ($bandP * 2); ?>px;
	width: <?php echo $calc - 2; ?>%;
	display: inline-block;
	vertical-align: top;
	margin: 10px 1% 0;
}

#pvg_videos .pvg_thumbnails {
	margin: 10px 0 0;
	width: 100%;
	text-align: center;
	display: table;
}

#pvg_videos .pvg_thumb {
	width: <?php echo $pvg_tc; ?>px;
	position: relative;
	display: table;
	margin: 0 auto;
}

#pvg_videos .pvg_thumb a {
	width: <?php echo $pvg_tc; ?>px;
	text-decoration: none;
	overflow: hidden;
	cursor: pointer;
	display: table;
}

#pvg_videos .pvg_thumb img {
	height: <?php echo $pvg_th; ?>px;
	width: <?php echo $pvg_tw; ?>px;
	<?php echo $paddingC; ?>
	<?php echo $paddingW; ?>
	<?php echo $borderC; ?>
	<?php echo $borderW; ?>
	<?php echo $borderS; ?>
	<?php echo $borderR; ?>
	float: none !important;
	margin: 0 !important;
	vertical-align: top;
	overflow: hidden;
}

#pvg_videos .pvg_thumb .pvg_to {
	<?php echo $textL; ?>
	<?php echo $textW; ?>
	<?php echo $textS; ?>
	<?php echo $textZ; ?>
	<?php echo $textC; ?>
	<?php echo $textB; ?>
	text-transform: capitalize;
	text-align: left;
	margin-top: 5px;
	overflow: hidden;
	display: block;
}

#pvg_videos .pvg_thumb:hover .pvg_to {
    <?php echo $textH; ?>
}

#pvg_videos .pvg_thumb .pvg_ti {
	<?php echo $textC; ?>
	<?php echo $borderR; ?>
	top: <?php echo $pvg_th - 26; ?>px;
    margin: <?php echo $bandP; ?>px;
	text-transform: capitalize;
	background-color: #000;
	padding: 5px 10px;
	overflow: hidden;
	display: block;
	height: 16px;
    opacity: 0.8;
    text-align: left;
    position: absolute;
}

#pvg_videos .pvg_thumb:hover .pvg_ti {
    height: <?php echo $pvg_th - 10; ?>px;
    margin: <?php echo $bandP; ?>px;
    <?php echo $textH; ?>
    top: 0;
}

#pvg_videos .pvg_thumb_hq {
	max-height: <?php echo $pvg_ph; ?>px;
	max-width: <?php echo $pvg_pw; ?>px;
	padding-bottom: 56.25%;
	position: relative;
	margin: 0 auto;
	height: 0;
	width: 100%;
}

#pvg_videos .pvg_thumb_hq iframe {
	min-height: <?php echo $pvg_th; ?>px;
	min-width: <?php echo $pvg_tw; ?>px;
	background-color: #000;
	position: absolute;
	margin: 0 auto;
    height: 100%;
    width: 100%;
    padding: 0;
    bottom: 0;
    right: 0;
    left: 0;
    top: 0;
}

#pvg_videos #pvg_tbox {
	height: <?php echo $pvg_ph; ?>px;
	width: <?php echo $pvg_pw; ?>px;
}

#pvg_videos .pagination {
	margin: 20px 0 0;
	width: 100%;
	text-align: center;
	display: inline-block;
	float: none;
}

#pvg_videos .pagination input[type="button"] {
	margin: 0 2px;
	width: auto;
}

#pvg_videos .pagination input[type="button"].current_page {
	text-decoration: underline;
	font-weight: bold;
}

.fluid-width-video-wrapper{
	padding: 0 0 56.25% !important;
}