<?php

 defined ('ABSPATH') or die (); //security 

 /***************************************************/
 /***  I think each function are self explained   ***/
 /***************************************************/

 if (!class_exists('pvg_Init')) 
 {    
    class pvg_Init
    {
       /**
        * Plugin [Admin] Menu title
        * @var string
        **/

        public $menuTitle = 'WP PVGallery';

       /**
        * Plugin [Admin] Capability (Who has access)
        * @var string - WP specific
        **/
        public $capability = 'manage_options';

       /**
        * Plugin [Admin] Menu Slug
        * @var string
        **/

        public $pvgSlug = 'wpPlaylistVG';

       /**
        * (Singleton) Insatnce of wpPlaylistVG object
        * @var pvgInit
        **/

        private static $_instance = null;

       /**
        * Plugin table names
        * @var array () - wp_prefix == true
        **/
        protected $pvgtblName = array (
            0 => 'pvg_list', 1 => 'pvg_videos', 
        );

       /**
        * Shortcode tag
        * @var string
        **/
        protected $shortcodeTag = 'pvg';

        public function pvg_getStypes ()
        {
            return $this->search_by;
        }  

        public function pvg_getTables ($dbAction = null)
        {
            global $wpdb;

            foreach ($this->pvgtblName as $k)
            {
                $pvgdb[] = $wpdb->prefix. $k;
            }
        
            return $pvgdb;
        }

        public function pvg_WPactions ()
        {   
            //register_activation_hook
            if (function_exists ('is_multisite') && is_multisite()) 
            {
                register_activation_hook  (STUBEG_PATH.'/pvg.php', array ($this, 'pvg_ActivateActionNetwork'));
            
            }else{
            
                register_activation_hook   (STUBEG_PATH.'/pvg.php', array ($this, 'pvg_ActivateAction'));
            }
            
            register_deactivation_hook (STUBEG_PATH.'/pvg.php', array ($this, 'pvg_DeactivateAction'));
            add_shortcode ($this->shortcodeTag, array ($this, 'pvg_shortCode'));
            
            if (is_admin ()) add_action ('admin_menu', array ($this, 'pvg_AddToDashboard'));

            //Front end Css/Js
            add_action ('wp_enqueue_scripts', array ($this, 'pvg_ActivateFrontEndScripts')); 

            //Pagination ajax action
            add_action ('wp_ajax_pvg_AjaxPagination', array ($this, 'pvg_AjaxPagination'));
            add_action ('wp_ajax_nopriv_pvg_AjaxPagination', array ($this, 'pvg_AjaxPagination'));

            //Just in case.
            if (is_admin ())
            {
                //Search ajax action
                add_action ('wp_ajax_pvg_AjaxRetRequests', array ($this, 'pvg_JqRetRequestS'));
                //List ajax action
                add_action ('wp_ajax_pvg_AjaxRetRequestl', array ($this, 'pvg_JqRetRequestL'));
                //Option ajax action
                add_action ('wp_ajax_pvg_AjaxRetRequesopn', array ($this, 'pvg_JqRetRequesOpn'));
                //Only apply action if we are on the plugin page. 
                if (isSet ($_GET ['page']) && $_GET ['page'] == $this->pvgSlug)
                {
                    add_action ('admin_enqueue_scripts', array ($this, 'pvg_ActivateAdminJsFiles'));
                    add_action ('admin_enqueue_scripts', array ($this, 'pvg_ActivateAdminCssFiles')); 
                }
            }

            add_filter ('plugin_action_links', array ($this, 'pvg_wpSettingLink'), 10, 2);
            //add_action ('admin_head', array ($this, 'pvg_WPCust'));
        }

        public function pvg_getShortCtag ()
        {
            return $this->shortcodeTag;
        }

       /**
        * install
        **/ 
        public function pvg_ActivateAction () 
        {
            if (!current_user_can ('activate_plugins')) return false;

            $plugin = isset ($_REQUEST['plugin'])?$_REQUEST['plugin']:'';

            check_admin_referer ('activate-plugin_'.$plugin);
            add_option ('pvg_Activated', '_pvg_activated_');
            add_option ('wpPlaylistVG_db_ver',  '1.2.0');

            $pvgdb = $this->pvg_getTables ();

            //Add default options for gallery
            pvg_options::opninst ()->setOpnDefault ();
            
            require_once ABSPATH . 'wp-admin/includes/upgrade.php';

            $pvgSql =  "CREATE TABLE IF NOT EXISTS {$pvgdb[0]} (
                        id mediumint(9) UNSIGNED NOT NULL AUTO_INCREMENT,
                        pl_name varchar(20) DEFAULT '' NOT NULL,
                        dateCreated datetime NOT NULL default '0000-00-00 00:00:00',
                        PRIMARY KEY  (id));";
            dbDelta ($pvgSql);

            $pvgSql .= "CREATE TABLE IF NOT EXISTS {$pvgdb[1]} (
                        id mediumint(9) UNSIGNED NOT NULL AUTO_INCREMENT,
                        pl_id mediumint(9) NOT NULL,
                        yt_id varchar (20) DEFAULT '' NOT NULL, 
                        yt_title varchar (150) DEFAULT '' NULL,
                        yt_image varchar (150) DEFAULT '' NULL,
                        yt_info longtext NULL,
                        yt_udate varchar (100) NOT NULL DEFAULT '0000-00-00 00:00:00',
                        v_type varchar (20) DEFAULT '' NULL, 
                        dateAdded datetime NOT NULL default '0000-00-00 00:00:00',
                        PRIMARY KEY  (id));";
            dbDelta ($pvgSql);
        }

        public function pvg_ActivateActionNetwork ($networkwide)
        {
            global $wpdb;

            $current_blog = $wpdb->blogid;
            $network_bids = $wpdb->get_col ("SELECT blog_id FROM {$wpdb->blogs}");

            foreach ($network_bids as $nids)
            {
                switch_to_blog ($nids);
                $this->pvg_ActivateAction ();
            }

            switch_to_blog ($current_blog);
            return;
        }

        public function pvg_WPCust ()
        {
            $image = plugin_dir_url (STUBEG_PATH.'pvg.php')."logo.png";

            echo '<style>
                    #playlist-video-gallery.active {
                        background: url("'.$image.'") no-repeat scroll right top rgba(0, 0, 0, 0);
                    }
                    #playlist-video-gallery.active .plugin-description > p {
                       padding-right: 150px;
                    }
                  </style>';
        }

        public function pvg_wpSettingLink ($links, $file)
        {
            static $thisFile; //ewwww
            $opnlink    = 'options-general.php?page=wpPlaylistVG';
            $optionlink = '';

            if (!$thisFile) $thisFile = plugin_basename (STUBEG_PATH.'pvg.php');
            if ($file == $thisFile)
            {
                $optionlink = '<a href="'.$opnlink.'">'.__ ('Options').'</a>';
                array_unshift ($links, $optionlink);
            }
            return $links;
        }

       /**
        * Dashboard admin menu [Settings->{plugin_slug}]
        **/  
        public function pvg_AddToDashboard () 
        { 
            $icon = STUBEG_PURL.STUBEG_DEFTHEME."images/pvg-icon.png";

            add_menu_page (PLUGIN_TITLE, $this->menuTitle, 
                $this->capability, $this->pvgSlug, array ($this, 'pvg_loadAdminPage'), 
                $icon, 81.12510);
        }

       /**
        * jQuery pagination
        **/ 
        public function pvg_AjaxPagination ()
        {
            header ('Content-Type: application/json');
            
            echo pvg_pagi::pgSingle ()->AjaxPagination ();
            exit;
        }

       /**
        * jQuery options
        **/ 
        public function pvg_JqRetRequesOpn ()
        {
            header ('Content-Type: application/json');
            
            if ($_POST ['typekey'] == 'pvg_option_cb') {
                echo pvg_list::pvglsing()->pvg_removeDeadVids ();
            }

            if ($_POST ['typekey'] == 'pvg_option_cg') {
                echo pvg_options::opninst ()->pvg_updateOption ();
            }

            if ($_POST ['typekey'] == 'pvg_checkStat'){
                echo pvg_general::gsing ()->myStatus ();
            }
            exit;
        }

       /**
        * jQuery listnames
        **/ 
        public function pvg_JqRetRequestL ()
        {
            header ('Content-Type: application/json');

            if ($_POST ['typekey'] == 'upDatePage')
            {
                echo pvg_general::gsing ()->pvg_addCodeToPage ();

            }else{
            
                echo pvg_List::pvglsing ()->pvg_parseListName ();
            }
            exit;
        }

       /**
        * jQuery search
        **/ 
        public function pvg_JqRetRequestS ()
        {
            header ('Content-Type: application/json');
            echo pvg_List::pvglsing ()->pvg_SearchAction ();
            exit;
        }

       /**
        * Deactivate
        **/ 
        public function pvg_DeactivateAction () 
        {
             delete_option ('pvg_Activated');
        } 

       /**
        * Load main admin page 
        * [Settings->{plugin_slug}->main_page]
        **/
        public function pvg_loadAdminPage () 
        {   
            if (!is_admin ()) 
            {
                wp_die (__('You don`t have sufficient permission to access this page'));  
            }
            require_once STUBEG_PATH.'pvg_admin.php';
        }

       /**
        * Register/Enqueue Admin Css scripts
        **/
        public function pvg_ActivateAdminCssFiles () 
        {
            $csspath = STUBEG_PURL.STUBEG_DEFTHEME;
            wp_register_style ('pvg_style.css', $csspath.'css/pvg_admin.css', array (), 'screen');
            wp_enqueue_style ('pvg_style.css');
        }

       /**
        * Register/Enqueue FrontEnd Css scripts
        **/
        public function pvg_ActivateFrontEndScripts ()
        {
            $footer = true;

            if (function_exists ('WPMinify')) $footer = false;

            $csspath = STUBEG_PURL.STUBEG_DEFTHEME;
            $jspath  = STUBEG_PURL.STUBEG_DEFTHEME.'js/';            
            
            if (wp_is_mobile ())
            {
                wp_register_style ('css_front', $csspath.'css/pvg_mobile.css', array (), 'screen');
            
            }else{

                wp_register_style ('css_front', $csspath.'css/pvg_frontend.php', array (), 'screen');
            }

            //Make sure jquery/ui are loaded
            if (!wp_script_is ('jquery'))
            {
                wp_enqueue_script ('jquery', 'http://ajax.googleapis.com/ajax/libs/jquery/1.10.2/jquery.min.js', '', '', $footer);
            }

            //Front JS
            wp_register_script ('ytAPI', 'http://www.youtube.com/iframe_api', array (), true, $footer);
            wp_register_script ('front_js', $jspath.'pvg_front.js', array ('jquery'), true, $footer);
            
            wp_register_script ('colorbox_js', $jspath.'libs/colorbox/jquery.colorbox-min.js', array ('jquery'), true, $footer);
            wp_register_style ('colorbox_css', $jspath.'libs/colorbox/colorbox.css', array (), 'screen');
            wp_localize_script ('front_js', 'pvgjsfront', array ('ajaxfront' => admin_url ('admin-ajax.php'), 
                                'postCommentNonce' => wp_create_nonce ('pvg-post-nonce')));
        }

       /**
        * Register/Enqueue JS Scripts - Admin panel
        **/
        public function pvg_ActivateAdminJsFiles () 
        {
            global $wp_version;

            $footer = true;

            if (function_exists ('WPMinify')) $footer = false;

            if (!wp_script_is ('jquery')) 
            {   
                if (3.5 <= $wp_version)
                {
                    wp_enqueue_script ('jquery'); //load default wp script

                }else{
                
                    wp_enqueue_script ('jquery', 'http://ajax.googleapis.com/ajax/libs/jquery/1.10.2/jquery.min.js', '', '', $footer);
                }
            }
            
            if (3.5 <= $wp_version)
            {
                wp_enqueue_style ('wp-color-picker');
                wp_enqueue_script ('wp-color-picker');

            }else{
 
                wp_enqueue_style ('farbtastic');
                wp_enqueue_script ('farbtastic');
            }
            
            $jspath = STUBEG_PURL.STUBEG_DEFTHEME.'js/';

            //List js
            wp_enqueue_script ('pvgjsfiles', $jspath.'pvg_lists.js', array ('jquery'), '', $footer);
            
            //Options js
            wp_enqueue_script ('pvgjsfilesopn', $jspath.'pvg_options.js', array ('jquery'), '', $footer);

            //Search js
            wp_enqueue_script ('pvgjsfilest', $jspath.'pvg_search.js', array ('pvgjsfiles'), '', $footer);    

            //Tab menu js
            wp_enqueue_script ('pvgtabmenu.js', $jspath.'pvg_tabmenu.js', array (), '', $footer); 

            //Localize Search/List js
            wp_localize_script ('pvgjsfiles', 'pvgjs', array ('ajaxurl' => admin_url ('admin-ajax.php'), 
                                'postCommentNonce' => wp_create_nonce ('pvg-post-nonce')));
        }

        private function loadFrontScripts ()
        {
            $options = pvg_options::opninst ()->get_galOptions ();
            $status  = ob_get_status();

            if (substr_count ($_SERVER ['HTTP_ACCEPT_ENCODING'], 'gzip')) 
            {
                if (isSet ($status ['name']) && !$status['name'] == 'ob_gzhandler') 
                {
                    ob_start ('ob_gzhandler'); 
                }
            }else {

                ob_start ();
            }

            wp_print_styles  ('css_front');
            wp_print_scripts ('ytAPI');
            wp_print_scripts ('front_js');

            if ($options ['cont'] == 'kt')
            {
                wp_print_styles  ('colorbox_css');
                wp_print_scripts ('colorbox_js');
            }
        }

       /**
        * Add shortcode
        **/
        public function pvg_shortCode ($atts)
        {   
            $params = array ();

            if (!empty ($atts) && is_array ($atts))
            {
                $this->loadFrontScripts ();

                extract (shortcode_atts (
                    array ('channel' => '', 'list' => '', 'playlist' => '',  
                           'favorite' => '', 'arrange' => '', 'limit' => '', 
                           'orderby' => '',), $atts));

                $params ['arrange'] = preg_match ('/^(asc|desc)$/i', $arrange)?$arrange:'desc';
                $params ['limit']   = preg_match ('/^[0-9]{1,3}$/', $limit)?$limit:'';
                $params ['orderby'] = $orderby;

                if (!empty ($list)) 
                {
                    $params ['t']['d'] = strip_tags ($list);
                    $params ['t']['s'] = "list";
 
                }else if (!empty ($playlist)) {

                    $params ['t']['d'] = strip_tags ($playlist);
                    $params ['t']['s'] = "playlist";

                }else if (!empty ($favorite)) {

                    $params ['t']['d'] = strip_tags ($favorite);
                    $params ['t']['s'] = "favorite";

                } else if (!empty ($channel)) {

                    $params ['t']['d'] = strip_tags ($channel);
                    $params ['t']['s'] = 'channel';
                }

                ob_start ();

                $content = pvg_List::pvglsing ()->pvg_parseShortCode ($params);
                $data    = ob_get_clean ();

                //if buffer is empty.
                if (empty ($data))
                {
                    return $content;
                
                }else{

                    return $data;
                } 
            }
        }

        //Class singleton
        public static function pvgsing ()
        {
            is_null (self::$_instance) && self::$_instance = new self;
            return self::$_instance;
        }
    }
 }