<?php

defined ('ABSPATH') or die (); //security

if (!class_exists ('pvg_List'))
{     
   class pvg_List 
   {
       /**
        * (Singleton) Insatnce of wpPlaylistVG object
        * @var pvg_list
        **/
        private static $instance = null;

       /**
        * Hold Json data
        * @var array ();
        **/
        private $json_data = null;

       /**
        * You tube Start Index (start-index)
        * @var int  
        **/
        private $sIndex = 1;

       /**
        * You tube - Show Per Page (max-results)
        * @var int - Change this to show more, max 50
        **/
        private $perPage = 10;

       /**
        * Status message used for json errors/success 
        * This array will be moved on our next update
        * @var array ()
        **/
        private $statusMSG = array (
           0 => array ('code' => 0, 'msg' => '<b>Success, Playlist Created</b>'),
           1 => array ('code' => 1, 'msg' => '<b>Playlist already exists</b>'),
           2 => array ('code' => 2, 'msg' => '<b>Incorrect playlist name</b>'),
           3 => array ('code' => 3, 'msg' => '<b>No videos were found!</b>'),
           4 => array ('code' => 0, 'msg' => '<b>Success, Playlist has been removed</b>'),
           5 => array ('code' => 1, 'msg' => '<b>Reminder: You dont seem to have a list created, please create one first.</b>'),
        );

       /**
        * Status used to send via json for errors/success
        * @var string
        */
        private $getStatusMSG;

       /**
        * Hold listname input
        * @var string
        **/
        protected $listName;

       /**
        * Hold listname input
        * @var string
        **/
        protected $dbparams;

       /**
        * Hold listid for later use
        * @var int
        **/
        protected $listID;

       /**
        * Search for video, and populate jquery data
        * return @array () - jquery data
        **/
        public function pvg_SearchAction ()
        {
            $ytcurpg    = 1;
            $nextPage   = NULL;
            $prevPage   = NULL;
            $retVidinfo = array ();

            if( $_POST['pagiType'] === "Next" ) $nextPage = $_POST['pagiInt'];
            if( $_POST['pagiType'] === "Prev" ) $prevPage = $_POST['pagiInt'];

            if( !empty ($_POST ['searchType']) && !empty ($_POST ['searchID']) ) {

                pvg_validator::validateNonce ($_POST ['postCommentNonce']);

                $getVideos = pvg_youtubeapi::run($_POST ['searchID'], $_POST ['searchType'], $prevPage, $nextPage)->getYoutubeData();
            }

            if( empty($getVideos) ) {

                $this->json_data = _ ('<strong>'.$this->statusMSG [3]['msg'].'</strong>');

            }else{
                
                try {

                    if( is_array($getVideos) && !empty($_POST['searchID']) )
                    {
                        $jsontpl = new pvg_template (STUBEG_PATH.STUBEG_DEFTHEME);

                        $jsontpl->pvgRenderTemplate ('pvg_sresults.php');
                        $jsontpl->searchType = $_POST['searchType'];
                        $jsontpl->searchID   = $_POST['searchID'];
                        $jsontpl->ytinfo     = $getVideos;
                        $jsontpl->ytcurPage  = $ytcurpg;
                        $jsontpl->showlist   = $this->pvg_getCreatedList ();
                        $this->json_data     = $jsontpl->pvgOutputTplView ();
                    }
                }catch (Exception $e){

                    $this->json_data = '';
                    is_admin ()?$e:_ ('Json data has left the building!!!');
                }
            }
        
            $send_json = json_encode (array ('pvgjData' => $this->json_data));

            return $send_json;
        }

       /**
        * Create our list
        **/
        public function pvg_createList ()
        {
            global $wpdb;

            $pvg_table = pvg_Init::pvgsing ()->pvg_getTables ();

            $is_double = $wpdb->get_results (
                $wpdb->prepare (
                    "SELECT pl_name FROM {$pvg_table [0]} WHERE pl_name = %s",
                    strtolower ($this->listName)));         
            /*
            $getdata = $wpdb->get_results (
                $wpdb->prepare (
                    "SELECT pl_name FROM {$pvg_table [0]}"));
            */
            if ($wpdb->num_rows >= 1) 
            {
                $this->getStatusMSG = __ ($this->statusMSG [1]);
                return false;
            }

            $lname = strtolower ($this->listName);
            $today_is = date ('Y-m-d H:i:s');

            $pvg_sql = $wpdb->query ($wpdb->prepare (
              "INSERT INTO {$pvg_table [0]} VALUES (%d, %s, %s)", 0, $lname, $today_is));

            if ($pvg_sql) $this->getStatusMSG = __ ($this->statusMSG [0]);
            
            return false;
        }

        public function pvg_removeDeadVids ()
        {
            global $wpdb;

            $pvg_table = pvg_Init::pvgsing ()->pvg_getTables ();
            $pvg_check = $wpdb->get_results ("SELECT id, yt_id FROM {$pvg_table [1]}");
            $removed   = 0;

            foreach ($pvg_check as $k) {

                $chkVideos = pvg_youtubeapi::run($k->yt_id, 'video')->getServiceInfo();

                if ($chkVideos['http_code'] != 200) {
                   
                   $removed += 1;
                   $wpdb->get_results ("DELETE FROM {$pvg_table [1]} WHERE id = {$k->id}");
                }  
            }

            return json_encode ($removed);
        }

       /** 
        * Get created list in db
        * @var array
        **/
        public function pvg_getCreatedList ()
        {
            global $wpdb;

            $data = '';

            $pvg_table = pvg_Init::pvgsing ()->pvg_getTables ();

            $pvg_list = $wpdb->get_results (
                "SELECT l.id, l.pl_name, l.dateCreated, COUNT(v.pl_id) as total_vids  
                    FROM {$pvg_table [0]} as l LEFT JOIN {$pvg_table [1]} as v 
                    ON l.id = v.pl_id GROUP BY l.id ORDER BY l.id DESC", ARRAY_A
            );        

            if ($wpdb->num_rows < 1)
            {
                $this->getStatusMSG = __ ($this->statusMSG [5]);
    
            }else{

                $data = $pvg_list;
            }

            //Lets return videos in same array
            if (is_array ($data))
            {
                foreach ($data as $k => $v) 
                {
                    $pvg_videos = $wpdb->get_results (
                        "SELECT * FROM {$pvg_table [1]} WHERE pl_id = '{$v ['id']}' 
                         ORDER BY dateAdded DESC", ARRAY_A);

                    $data [$k]['videos'] = (empty ($pvg_videos))?0:$pvg_videos; 
                }
            }
            return $data; 
        }

        public function pvg_stdOutView ($list = null)
        {
            global $wpdb;

            $options   = pvg_options::opninst ()->get_galOptions ();
            $pvg_table = pvg_Init::pvgsing ()->pvg_getTables ();
            $pvgPage   = isSet ($_REQUEST ['video_page'])?$_REQUEST ['video_page']:1;

            $dbtotal = $wpdb->get_var ($wpdb->prepare (
                "SELECT COUNT(*) FROM {$pvg_table [1]} WHERE 
                pl_id = %s", $this->listID
            ));

            $o  = "DESC";
            $of = 0;
            $lr = ceil ($dbtotal / $options ['tppg']);

            if ($pvgPage > $lr) $pvgPage = $lr;
            if ($pvgPage > 1) $of = ($options ['tppg'] * $pvgPage) - $options ['tppg'];
        
            //$l = "LIMIT {$of}, {$options ['tppg']}";
            
            if( $list != null ) {

                $this->pvg_checkCatID ($list, 'name');
            }

            if (isSet ($this->listID) && $this->listName != 'all')
            {
//                if (preg_match ('/^[0-9]{1,3}$/', $this->dbparams ['limit']))
//                {
//                    $l = 'limit '.$this->dbparams ['limit'];
//                    $dbtotal = $this->dbparams ['limit'];
//                }
//
                //double check
                if( preg_match('/^asc|desc$/i', $this->dbparams ['arrange']) ) {
                    $o = strtoupper ($this->dbparams ['arrange']);
                }

                $dbdata = $wpdb->get_results($wpdb->prepare(
                    "SELECT yt_id FROM {$pvg_table [1]} WHERE pl_id = %s ORDER BY dateAdded {$o}",
                    $this->listID), ARRAY_A);

            }else if ($this->listName == 'all') {

                $dbdata = $wpdb->get_results("SELECT yt_id FROM {$pvg_table [1]} ORDER BY id {$o} {$l}", ARRAY_A);
            }

            if( !empty($dbdata) ) {

                $vids = pvg_youtubeapi::run($dbdata, 'video')->getYoutubeData();
                $vids ['orderby'] = $this->dbparams ['arrange'];
                $vids ['ttl'] = count($dbdata);

                return $this->pvg_startTemplate ($vids, 'list'); 
            }   
        
            return false;
        }

        public function pvg_startTemplate ($data, $params = null)
        {
            $jsontpl = new pvg_template (STUBEG_PATH.'vtypes/');

            $jsontpl->pvgRenderTemplate ('pvg_videos.php');
            $jsontpl->videos = $data;
            $jsontpl->vtype  = $params;
            $frontView = $jsontpl->pvgOutputTplView ();

            return $frontView;
        }

        public function pvg_parseShortCode ($params)
        {
            if (!empty ($params ['t']['s']) && $params ['t']['s'] == 'list') 
            {  
                return $this->pvg_getSingleList ($params);

            }else {
            
                if (!empty ($params ['t']['s']))
                {
                    return $this->pvg_getYTDirect ($params);
                }
            }
            return false;
        }

       /**
        * Get channel/fav/playlist
        **/
        public function pvg_getYTDirect ($params = null, $orderby = null)
        {   
            if (is_null ($params ['t']['s'])) return false;

            $options = pvg_options::opninst ()->get_galOptions ();
            $pvgPage = isSet ($_REQUEST ['video_page'])?$_REQUEST ['video_page']:1;

            if ($pvgPage > 1)
            {
                $pvgPage = ($options ['tppg'] * $pvgPage) + 1 - $options ['tppg'];
            }

            $search = pvg_youtubeapi::run($params['t']['d'], $params['t']['s'], $params ['orderby']);

            $c = $params ['limit'];

            $videos = $search->getYoutubeData();
            $videos['tfound'] = (int)$search->getTotalResults();

            if (!empty ($params ['limit']) && preg_match ('/^[0-9]+$/', (int)$params ['limit']))
            {
                $onPage = ($pvgPage <= 1)?0:$pvgPage; 
                $videos['tfound'] = (int) $search->getTotalResults();

                if (isSet ($_REQUEST ['video_page']) && preg_match ('/^[0-9]+$/', $_REQUEST ['video_page']))
                {
                    $c = ($videos['tfound'] + $options ['tppg'])-($options ['tppg'] * $_REQUEST ['video_page']);
                }

                foreach ($videos as $key => $val)
                {
                    $videos[$key] = array_slice ($videos[$key], 0, $c, true);
                }
            }

            return $this->pvg_startTemplate ($videos, $params);
        }

        public function pvg_getSingleList ($params = null)
        {
            if (is_null ($params ['t']['s'])) return false;

            if ($params ['t']['d'] == 'all')
            {
                $this->listName = 'all';
                return $this->pvg_stdOutView ();
            
            }else{

                if (pvg_validator::validateName ($params ['t']['d']) && $this->pvg_checkCatID ($params ['t']['d'], 'name'))
                {
                    $this->listName = $params ['t']['d'];
                    $this->dbparams = $params;
                    echo $this->pvg_stdOutView ();
                }
            }
            return false; 
        }

        public function pvg_showCreatedList ()
        {   
            $data = $this->pvg_getCreatedList ();

            try {

                $jsontpl = new pvg_template (STUBEG_PATH.STUBEG_DEFTHEME);

                $jsontpl->pvgRenderTemplate ('pvg_lresults.php');
                $jsontpl->list_data = $data;
                $this->json_data = $jsontpl->pvgOutputTplView ();

             }catch (Exception $e){

                is_admin ()?$e:_ ('Json data has left the building!!!'); 
            }            
            return $this->json_data;
        }

       /**
        * Check video existance in the db and get its
        * list name
        * @var string
        **/
        public function pvg_checkVideo ($vid = '')
        {
            global $wpdb;

            $pvg_table = pvg_Init::pvgsing ()->pvg_getTables ();

            if (!empty ($vid))
            {
                $pvg_data = $wpdb->get_results (
                    $wpdb->prepare (
                        "SELECT l.pl_name  
                         FROM {$pvg_table [1]} v INNER JOIN {$pvg_table [0]} l  
                         ON v.pl_id = l.id WHERE v.yt_id = %s", $vid));
                
                if ($wpdb->num_rows >= 1)
                {
                    return $pvg_data [0]->pl_name;
                }
            }
            return false;
        }

       /**
        * Get video ready to be inserted 
        * in to database
        * @var int (catVid), 
        * @var int  (catlist)
        * Pass to function for initial insert
        **/
        public function pvg_addVideotoList () 
        {
            if (!empty ($_POST ['catVid']) && !empty ($_POST ['catlist']))
            {
                if ($this->pvg_checkCatID ($_POST ['catlist']))
                {
                    $this->pvg_updateVideo ($_POST ['catVid'], $_POST ['catlist']);
                }
            }
        }

        //Check video/list, if video does not already belongs to list, move it.
        public function pvg_updateVideo($vid = '', $id = null) {

            global $wpdb;

            $pvg_table = pvg_Init::pvgsing ()->pvg_getTables ();
            $today_is  = date ('Y-m-d H:i:s');

            //First get videos information
            $info = pvg_youtubeapi::run($vid, 'video');

            if( $id == 'none' ) {

                //Delete video
                $wpdb->query($wpdb->prepare(
                    "DELETE FROM {$pvg_table [1]} WHERE yt_id = %s", $vid)
                );
            }

            $pvg_data = $wpdb->get_results($wpdb->prepare(
                "SELECT pl_id, yt_id FROM {$pvg_table [1]} WHERE yt_id = %s", $vid)
            );

            $video = $info->getYoutubeData();

            if( !empty($video) ) {

                $title  = $video[0]['title'];
                $thumbs = $video[0]['thumbnails'];
                $udates = $video[0]['published'];
                $others =  serialize (json_encode (array (
                    'channelTitle' => $video[0]['channelTitle'], 'description' => $video[0]['description'],
                    'likeCount' => $video[0]['likeCount'], 'viewCount' => $video[0]['viewCount'],
                    'duration' => $video[0]['duration'],
                )));

                if ($id > 0) {

                    $pvg_sql = $wpdb->query($wpdb->prepare(
                        "INSERT INTO {$pvg_table [1]} VALUES (%d, %d, %s, %s, %s, %s, %s, %s, %s)",
                        0, $id, "{$vid}", "{$title}", null, null, "{$udates}", "youtube", $today_is)
                    );
                }
            }
        }

        public function pvg_updateDBVideos ()
        {
            global $wpdb;

            $video = array ();
            $pvg_table = pvg_Init::pvgsing ()->pvg_getTables ();    
            $info = new pvg_youtubeapi ();
            $dbv = $wpdb->get_results ("SELECT * FROM {$pvg_table [1]}");

            if ($wpdb->num_rows >= 1 && !empty ($dbv))
            {
                foreach ($dbv as $yt)
                {
                    $info->searchVideo ($yt->yt_id, 'video'); 
                    $video = $info->getVidsAllGeneral (); 
                    
                    if ($video['length'][0][0]['yt$format'] == 5)
                    {
                        $title  = $video['title'][0]['$t'];
                        $thumbs = $video['thumb'][0];
                        $udates = $video['udate'][0]['$t'];
                        $others = serialize (json_encode (array (
                            'user'   => $video['credits'][0]['$t'],
                            'descp'  => $video['descp'][0]['$t'],
                            'likes'  => $video['likes'][0],
                            'views'  => $video['views'][0],
                            'length' => $video['length'][0][0]['duration'])));

                        $img = $thumbs [0]['url'];

                        if (!empty ($thumbs [2]) && $thumbs [2]['yt$name'] == 'hqdefault')
                        {
                            $img = $thumbs [2]['url'];
                        }

                        $wpdb->query (
                            $wpdb->prepare (
                                "UPDATE {$pvg_table [1]} 
                                    set yt_title = %s, yt_image = %s, yt_info = %s, pl_id = %d 
                                    WHERE id = %d", $title, $img, $others, $yt->pl_id, $yt->id));
                    }
                }
            }   
        }
        
        //Check List id before inserting video
        public function pvg_checkCatID ($id = null, $type = null)
        {
            global $wpdb;

            $goodtogo  = false;
            $pvg_table = pvg_Init::pvgsing ()->pvg_getTables ();

            if (is_null ($type) && preg_match ('/^[0-9]+$/', $id)) 
            {
                $field    = 'id = %d';
                $goodtogo = true;
            }

            if ($type == 'name' && pvg_validator::validateName ($id)) 
            {
                $field    = 'pl_name = %s';
                $goodtogo = true;
            }

            if ($id == 'none')
            {
                return true;
            }

            if ($goodtogo === true && $id != 'none')
            {
                $pvg_data = $wpdb->get_results (
                    $wpdb->prepare ( 
                        "SELECT id, pl_name FROM {$pvg_table [0]} WHERE {$field}", $id));

                if ($wpdb->num_rows == 1) 
                {
                    $this->listID = $pvg_data [0]->id;
                    return $pvg_data [0]->pl_name;    
                }
            }
            return false;
        }

        public function pvg_removeByVideoID ($param = null)
        {
            global $wpdb;

            $dis       = null;
            $goodtogo  = false;
            $pvg_table = pvg_Init::pvgsing ()->pvg_getTables ();

            if (preg_match ('/\_{1}/', $param)) 
            {
                $ids = explode ('_', $param);
        
                //Make sure this video exists
                $pvg_data = $wpdb->get_results ($wpdb->prepare ( 
                    "SELECT id FROM {$pvg_table [1]} WHERE id = %d and pl_id = %d",
                    $ids [0], $ids [1]));
                
                if ($wpdb->num_rows == 1) 
                {
                    //Delete video
                    $wpdb->query ($wpdb->prepare (
                        "DELETE FROM {$pvg_table [1]} WHERE id = %d", $pvg_data[0]->id));
                }
            }
            return false;
        }

        //Delete List from db [video's from selected list will be deleted]
        public function pvg_removeList ()
        {
            global $wpdb;

            if (ctype_digit ($_POST ['rmlist']))
            {
                if ($this->pvg_checkCatID ($_POST ['rmlist']))
                {
                    $pvg_table = pvg_Init::pvgsing ()->pvg_getTables ();

                    //Remove Videos from list
                    $wpdb->query (
                        $wpdb->prepare ("DELETE FROM {$pvg_table [1]} WHERE pl_id = %d",
                        $_POST ['rmlist']));

                    //Remove List
                    $del = $wpdb->query (
                                $wpdb->prepare ("DELETE FROM {$pvg_table [0]} WHERE id = %d",
                                $_POST ['rmlist']));

                    if ($del) $this->getStatusMSG = __ ($this->statusMSG [4]);
                }
            }
            return false;
        }

        //Parse list name
        public function pvg_parseListName ()
        {
            $send_cdblist = '';

            pvg_validator::validateNonce ($_POST ['postCommentNonce']);

            if (!empty ($_POST ['pvg_listname']) && $_POST ['typekey'] == 'clist')
            {
                $this->listName = $_POST ['pvg_listname'];

                if (!pvg_validator::validateName ($this->listName))
                {
                    $this->getStatusMSG = __ ($this->statusMSG [2]);

                }else {
     
                    $this->pvg_createList (); 
                }
            }

            if ($_POST ['typekey'] == 'cgetList') {
                $send_cdblist = $this->pvg_showCreatedList ();
            }

            if ($_POST ['typekey'] == 'cinVid') {
                $send_cdblist = $this->pvg_addVideotoList ();
            }

            if ($_POST ['typekey'] == 'crmList') {
                $this->pvg_removeList ();
            }

            if ($_POST ['typekey'] == 'crmVideo' && !empty ($_POST ['rmVideo'])) {
                $this->pvg_removeByVideoID ($_POST ['rmVideo']);
            }

            $send_json = json_encode (
                array (
                    'pvgjData' => $send_cdblist,
                    'pvgjMSG'  => $this->getStatusMSG
            ));
            return $send_json;
        }

        //I am aware of bad practice in singleton, use it if you want, but I like to have it around
        public static function pvglsing () 
        {
            is_null (self::$instance) && self::$instance = new self;
            return self::$instance;
        }
    }
}
